;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;Smooth Animation for Games
;by John Watson
;Your Computer, February 1982, page 52
;================================

@DFILE=400C

ORG 4087

;POKE 16514, Draw (255) or Erase (0) Flag
@FLAG
	FF

;POKE 16515 and 16516 with a number in the 
;range 1 to 791 which is the screen position for the 
;start of the drawing.
@PRINTAT
	0E 00

;POKE 16517 and 16518  with the address of the 
;start of the data for the drawing.
@DATA
	BA 40

@START				;<- USR Basic Enty.
	LD DE,(PRINTAT) 	;Print at position
	LD HL,(DFILE)		;Start of D-File
	ADD HL,DE 		;Add print position
	PUSH HL 		;PUSH print position
	LD DE,(DATA) 		;Start of image data
	LD A,(DE) 		;A=Number of Characters to print
	INC DE 			;First character to print
	POP BC 			;POP print posion
	LD H,A 			;H=Characters to print counter
@LOOP
	LD A,(FLAG) 		;A=FLAG value
	CP 00 	 		;Draw or Erase?
	JR Z,ERASE		;IF 0 THEN ERASE
	JR DRAW			;IF NOT 0 THEN DRAW
@ERASE
	LD A,00			;A=Space, " "
	JR DRAW2		;Erase Image
@DRAW
	LD A,(DE) 		;A=Character to print
@DRAW2
	LD (BC),A 		;Print it
	LD A,H 			;A=Character counter			
	LD L,01			;A=A-1 
	SUB L 			;
	RET Z 			;IF A=0 THEN RETURN
	INC DE 			;Next DATA point (Print position offset)
	LD H,A 			;Save counter in H
	PUSH HL 		;PUSH Counter
	LD A,(DE)		;A=Print position offset
	LD H,$00 		;HL=Print position offset
	LD L,A 			;
	ADD HL,BC 		;Add offset to current print position
	PUSH HL 		;PUSH print position
	POP BC 			;BC=Print position
	POP HL 			;POP counter
	INC DE 			;Next DATA point (Character to print)
	JR LOOP			;LOOP

;DATA table, table consists of print position
;offset followed by the character to print.
;For example...
;16 83 means add 16 to current print position
;then print character 83.

@IMAGEDATA
	16 83 1F 83 01 80 01 80
	01 80 01 83 1D 80 01 0A
	01 80 01 0A 01 80 1D 80
	01 80 01 80 01 80 01 80
	1E 05 02 85 1E 07 01 01
	02 02 01 84
